/**
 * Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.task;

import com.nbtaskfocus.model.internal.TaskItemImpl;
import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileUtil;
import org.openide.loaders.DataObject;
import org.openide.loaders.DataObjectNotFoundException;
import org.openide.util.Lookup;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
public class TaskItem extends TaskItemImpl {

    private static final Logger LOGGER = Logger.getLogger("nl.cloudfarming.client.task");
    private TaskComponent taskComponent;

    public String[] getTaskItemProperties() {
        String[] properties = {};
        try {
            FileObject taskFileObject = getTaskItemFileObject();
            DataObject taskDataObject = DataObject.find(taskFileObject);

            Lookup lookup = taskDataObject.getLookup();
            taskComponent = lookup.lookup(TaskComponent.class);

            properties = taskComponent.getTaskProperties();

        } catch (DataObjectNotFoundException ex) {
            LOGGER.log(Level.WARNING, "Could not find DataObject for Task FileObject: {0}", ex.getMessage());
        }

        return properties;
    }

    private FileObject getTaskItemFileObject() {
        File taskFile = new File(getItemPath());
        FileObject taskFileObject = FileUtil.toFileObject(taskFile);
        return taskFileObject;
    }
}
